	#include "multiio.h"
	#include <stdlib.h>
	#include <string.h>
        #include <io.h>
	#include "global.h"
	#include "asm6502_.h"

	#pragma warn -rch
	#pragma warn -pro

	char ts[400]; /* spazio per stringhe temporanee */

	#define MAX_INCLUDE_DEPTH 10


        /* basta un buffer piccolo. La bufferizzazione la facciamo noi. */
	/*	#undef YY_BUF_SIZE
   	#define YY_BUF_SIZE 512 */ 

	YY_BUFFER_STATE include_stack[MAX_INCLUDE_DEPTH];
	unsigned int line_number[MAX_INCLUDE_DEPTH]; /* # linea sorgente */
	char *include_name[MAX_INCLUDE_DEPTH];       /* nomi dei files */
	int include_stack_ptr=0;

/* Cambiamo il sistema standard di leggere l'input. */

	extern unsigned int buffer_getc(char *buf);
	extern int open_buffer (char *);
	extern void close_buffer ();

	extern char *macro_pointer;
	extern char CurrentMacroName[255];
	extern unsigned int CurrentMacroInstance;

        int param_num = 0;

	#define YY_INPUT(buf,result,max_size)     \
               {                                  \
		char c;                           \
		if(macro_pointer)                 \
                   {                              \
		    c = *(macro_pointer++);       \
		    result = c ? 1 : 0 ;          \
                   }                              \
                else                              \
		    result = buffer_getc( &c );   \
		buf[0] = c;                       \
	       };

		/* funzioni per le macro */

	  /* aggiunge una macro alla lista */
	extern void AddMacro(char *nome);
          /* cerca una macro (restituisce TRUE o FALSE) */
        extern int GetMacro(char *nome);
	  /* aggiunge il parametro 'nome_param' alla macro 'nome' */
	extern void AddMacroParam(char *nome, char *nome_param);
	  /* setta il puntatore al testo della macro a una macro */
	extern void SetMacroText(char *nome, char *text);
          /* restituisce il puntatore al testo della macro */
        extern char *GetMacroText(char *nome);
	  /* Setta il valore di un parametro */
	extern void SetMacroParam(char *nome, int numero, char *text);
	  /* restituisce il puntatore al valore attuale di un
	     parametro, oppure NULL se il parametro non esiste */
	extern char *GetMacroParam(char *nome, char *nome_param);
	  /* distrugge tutte le macro */
	extern void DestroyAllMacro();

	  /* restituisce il puntatore al prossimo carattere */
	extern char *GetBufferPointer();

          /* Salva il contesto della macro corrente */
	extern void MacroBufferPush();
          /* ripristina il contesto della macro piu' esterna */
	extern void MacroBufferPop();

	#define YY_USER_INIT { \
	                      line_number[0]=1;  \
			      CurrentMacroName[0] = '\0'; \
			     }


	typedef struct t_bufferstate{
				     YY_BUFFER_STATE buf;
				     struct t_bufferstate *next;
				    } bufferstate;

	bufferstate *first_bufferstate = NULL;  
        void push_bufferstate();
	void pop_bufferstate();
	void pop_all_bufferstates();

%x incl m1 m2 m3 m4 m5 m6 m_err me1 me2 me3 me_err

intero_d  [0-9]+
intero_h  "$"[0-9A-Fa-f]+
intero_o  "@"[0-7]+
intero_b  "%"(0|1|" ")+
intero_c  "'"[^\n\t\']"'"
simbolo [A-Za-z_][A-Za-z0-9_]*
stringa \"[^\n\"]+\"
commento ";".*
macroparam [^\n,\[\]]*

%%

"+"      return('+');
"-"      return('-');
"*"      return('*');
"/"      return('/');
"("      return('(');
")"      return(')');
"#"      return('#');
"="      return('=');
","      return(',');
">"      return('>');
"<"      return('<');
":"      return(':');

"&"      return(AND_OP);
"|"      return(OR_OP);
"!"      return(NOT_OP);

A        return(A);
X        return(X);
Y        return(Y);


ADC      return(ADC);
AND      return(AND);
ASL      return(ASL);
BCC      return(BCC);
BCS      return(BCS);
BEQ      return(BEQ);
BIT      return(BIT);
BMI      return(BMI);
BNE      return(BNE);
BPL      return(BPL);
BRK      return(BRK);
BVC      return(BVC);
BVS      return(BVS);
CLC      return(CLC);
CLD      return(CLD);
CLI      return(CLI);
CLV      return(CLV);
CMP      return(CMP);
CPX      return(CPX);
CPY      return(CPY);
DEC      return(DEC);
DEX      return(DEX);
DEY      return(DEY);
EOR      return(EOR);
INC      return(INC);
INX      return(INX);
INY      return(INY);
JMP      return(JMP);
JSR      return(JSR);
LDA      return(LDA);
LDX      return(LDX);
LDY      return(LDY);
LSR      return(LSR);
NOP      return(NOP);
ORA      return(ORA);
PHA      return(PHA);
PHP      return(PHP);
PLA      return(PLA);
PLP      return(PLP);
ROL      return(ROL);
ROR      return(ROR);
RTI      return(RTI);
RTS      return(RTS);
SBC      return(SBC);
SEC      return(SEC);
SED      return(SED);
SEI      return(SEI);
STA      return(STA);
STX      return(STX);
STY      return(STY);
TAX      return(TAX);
TAY      return(TAY);
TSX      return(TSX);
TXA      return(TXA);
TXS      return(TXS);
TYA      return(TYA);

ORG      return(ORG);
DD       return(DD);
DB       return(DB);
DW       return(DW);

EQU      return(EQU);

{commento}"\n"          {
			 line_number[include_stack_ptr]++;
			 return(END_OF_LINE);
			}
{commento}              { return(END_OF_LINE); }

{intero_d}              {
			  yylval.intero = (unsigned int) strtol(yytext,NULL,10);
			  if (yylval.intero > 0xFF)
				 return(INTERO16);
			  else
				 return(INTERO8);
			}
{intero_h}              {
			  yylval.intero = (unsigned int) strtol(yytext+1,NULL,16);
			  if (yylval.intero > 0xFF)
				 return(INTERO16);
			  else
				{
				 if(strlen(yytext)>3)
				       return(INTERO16);
				 else
				       return(INTERO8);
				}
			}

{intero_o}              {
			  yylval.intero = (unsigned int) strtol(yytext+1,NULL,8);
			  if (yylval.intero > 0xFF)
				 return(INTERO16);
			  else
				{
				 if(strlen(yytext)>=4)
				       return(INTERO16);
				 else
				       return(INTERO8);
				}
			}

{intero_b}              {
			  yylval.intero = (unsigned int) strtol(yytext+1,NULL,2);
			  if (yylval.intero > 0xFF)
				 return(INTERO16);
			  else
				{
				 if(strlen(yytext+1)>8)
				       return(INTERO16);
				 else
				       return(INTERO8);
				}
			}

{intero_c}              {
			  yylval.intero = *(yytext+1);
			  return(INTERO8);
			}

{simbolo}   {
	      strcpy(ts,yytext);
	      if(!op_c) strupr(ts);      /* upper case */

	      /* controlliamo che non sia una macro */
	      if (GetMacro(ts))
		 {                  
		  param_num = 0; /* numero del parametro che sta per essere parsato */
		  BEGIN(me1); /*inizia il parsing dei parametri */
		 }
	      else
		 {
                  char *ptp;
		  /* controlliamo che non sia il parametro di una macro */
		  if( (ptp=GetMacroParam(CurrentMacroName, ts))!=0 )
		      {
		       MacroBufferPush();
                       push_bufferstate();
		       macro_pointer = ptp;
		       CurrentMacroName[0] = '\0';
		      }
		  else
                      {
		       yylval.simbolo = ts;
		       return(SIMBOLO);
                      }
		 }
	    }

\#endm      {
	      /* ripristina il contesto piu' esterno */
	     MacroBufferPop();
             pop_bufferstate();
            }

{stringa}   {
	     strcpy(ts,yytext);
	     ts[strlen(ts)]=0;
	     yylval.simbolo = ts+1;
	     return(STRINGA);
	    }

[ \f\r\t\v]     ;

"\n"       { line_number[include_stack_ptr]++;
	     return(END_OF_LINE);
	   }

<incl,INITIAL><<EOF>> {
	 if(macro_pointer)
            {
	     MacroBufferPop();
             pop_bufferstate();
            }
	 else
             {
	      if( include_stack_ptr <=0 )
	         {
		  DestroyAllMacro();
                  pop_all_bufferstates();
	          yyterminate();
	         }
	      else
                 {
                  close_buffer();
	          yy_delete_buffer( YY_CURRENT_BUFFER);
	          free(include_name[include_stack_ptr]);
		  yy_switch_to_buffer(include_stack[--include_stack_ptr] );
		 }
	     }
	}


\#include  BEGIN(incl);

<incl>[ \t\f\r\v]*  ;

<incl>{stringa}  {
		  if (include_stack_ptr >= MAX_INCLUDE_DEPTH)
		     {
		      printfile();
		      io_message("line %d : '#include' files nested too deeply.", line_number[include_stack_ptr-1]);
		      io_message_nl_here();
		      asm_error++;
		      BEGIN(INITIAL);
		      /*yyterminate(); */
		      return(END_OF_LINE);
		     }
		  include_stack[include_stack_ptr++] = YY_CURRENT_BUFFER;
		  yytext[yyleng-1]=0;
		  if(!open_buffer(yytext+1))
		     {
		      io_message("Could not open file %s.",yytext+1);
		      io_message_nl_here();
		      asm_error++;
		      include_stack_ptr--;  /* e' stupido, ma non impegna. */
		      BEGIN(INITIAL);
                      return(END_OF_LINE); 
/*		      yyterminate(); */ 
		     }
		  include_name[include_stack_ptr]=malloc(strlen(yytext+1)+1);
		  strcpy(include_name[include_stack_ptr],yytext+1);
		  yy_switch_to_buffer(yy_create_buffer(yyin, YY_BUF_SIZE));
		  line_number[include_stack_ptr]=1;
		  BEGIN(INITIAL);
		 }




\#macro		   BEGIN(m1);
<m1>{simbolo}      {
		    strcpy(ts, yytext);
		    AddMacro(ts);
		    BEGIN(m2);
                   }

<m2>"["	           BEGIN(m3);
<m2>"\n"           {
                    /* qui inizia il testo della macro (se e' senza parametri) */
		    SetMacroText(ts, GetBufferPointer() );
		    line_number[include_stack_ptr]++;
		    BEGIN(m6);
                   }

<m3>{simbolo}      {
                    AddMacroParam(ts, yytext);
		    BEGIN(m4);
                   } 

<m4>","	           BEGIN(m3);
<m4>"]"            BEGIN(m5);

<m5>"\n"           {
		    /* qui inizia il testo della macro */
		    SetMacroText(ts, GetBufferPointer() );
		    line_number[include_stack_ptr]++;
                    BEGIN(m6);
                   }
<m1,m2,m3,m4,m5>[ \t\f\r\v]   ;
<m1,m2,m3,m4,m5>.  BEGIN(m_err);

<m6>\#endm          BEGIN(INITIAL);
<m6>.               ;

<m_err>\#endm      {
	            printfile();
	            printline();
	            io_message("error in macro declaration.");
		    io_message_nl_here();
		    asm_error++;
		    BEGIN(INITIAL);
		   }

<m_err>.           ;
<m_err>"\n"        line_number[include_stack_ptr]++;


<m1,m2,m3,m4,m5,m6,m_err><<EOF>> {
	            printfile();
	            printline();
		    io_message("unexpected end of file.");
		    io_message_nl_here();
		    asm_error++;
		    BEGIN(INITIAL);
		   }

<me1>"["            {
		     BEGIN(me2);
		    }

<me1>[^\[ \t]       {
		     MacroBufferPush(); /*salva la posizione */
		     strcpy(CurrentMacroName, ts);
		     CurrentMacroInstance=loc_counter;
		     push_bufferstate();
		     macro_pointer = GetMacroText(CurrentMacroName);
		     BEGIN(INITIAL);
                    }

<me2>{macroparam}   {
		     SetMacroParam(ts, param_num++, yytext);
                     BEGIN(me3);
		    }

<me3>"]"            {
		     MacroBufferPush(); /*salva la posizione */
		     strcpy(CurrentMacroName, ts);
		     CurrentMacroInstance=loc_counter;
		     push_bufferstate();
		     macro_pointer = GetMacroText(CurrentMacroName);
		     BEGIN(INITIAL);
                    }

<me3>","            {
		     BEGIN(me2);
		    }

<me1,me2,me3>[ \t\f\r\v]   ;
<me1,me2,me3>.           BEGIN(me_err);

<me_err>.*\n       {
                    printfile();
	            printline();
		    io_message("error in macro call.");
		    io_message_nl_here();
		    asm_error++;
		    line_number[include_stack_ptr]++;
		    BEGIN(INITIAL);
		   }


<*>\n             line_number[include_stack_ptr]++;

<*>.       {
	     printfile();
	     printline();
	     io_message("lexical error : '%s'.",yytext);
	     io_message_nl_here();
	     asm_error++;
	   }



%%

void push_bufferstate()     
{
 bufferstate *newbsp;

 newbsp = malloc(sizeof(bufferstate));
 newbsp->next = first_bufferstate;
 newbsp->buf = YY_CURRENT_BUFFER;
 first_bufferstate = newbsp;
 yy_switch_to_buffer(yy_create_buffer(yyin, YY_BUF_SIZE));
}

void pop_bufferstate()
{
 bufferstate *bsp;

 if(first_bufferstate)
    {
     bsp = first_bufferstate;
     yy_delete_buffer(YY_CURRENT_BUFFER);
     yy_switch_to_buffer(first_bufferstate->buf);
     first_bufferstate = first_bufferstate->next;
     free(bsp);
    }
}

void pop_all_bufferstates()
{
 while(first_bufferstate)
	 pop_bufferstate();
}

int yywrap(void)
{
return(1);
}

