#ifndef __DISASSEMBLER__
#define __DISASSEMBLER__

#include <owl.h>
#include <window.h>
#include "process.h"
#include "defines.h"

typedef struct t_Breakpoint{
			    unsigned int address;
                            t_Breakpoint *next;
                           } Breakpoint;

// Finestra del disassemblatore
_CLASSDEF (TDisassembler)
class TDisassembler : public TWindow
{
 private:
    Breakpoint *FirstBreakpoint;
    char *op_string8(unsigned char);
    char *op_string16(unsigned int);
    TDisassembler **Myself;

    void ToggleBreakpoint(unsigned int);
    void RemoveAllBreakpoints(void);

 public:
    unsigned int LastValidAddress;
    T6502 *Processor;

    TDisassembler(PTWindowsObject AParent, TDisassembler **Me, T6502 *Proc);
    ~TDisassembler();
    virtual void SetupWindow();
    virtual BOOL IsBreakpoint(unsigned int);
    virtual LPSTR GetClassName();
    virtual void GetWindowClass(WNDCLASS &);
    virtual void ActivationResponse(WORD, BOOL);
    virtual void Paint(HDC, PAINTSTRUCT _FAR &);
    virtual void FindPC();

    virtual void WMLButtonDoubleClick(RTMessage) = [WM_FIRST + WM_LBUTTONDBLCLK];

    virtual void MenuDebugToggle(RTMessage) = [CM_FIRST + MENU_DEBUG_TOGGLE];
    virtual void MenuDebugRemoveAll(RTMessage) = [CM_FIRST + MENU_DEBUG_REMOVE];

    char *Disassembla(unsigned int, int *);

};


// Scroller verticale. Ha un comportamento 'stravagante' perche' deve
// adattare lo scorrimento alla lunghezza delle istruzioni, che e' variabile.

_CLASSDEF (TObjectVScroller)

class TObjectVScroller : public TScroller
{
 public:
   PTDisassembler Window;
   TObjectVScroller(PTDisassembler TheWindow, int TheXUnit
	 , int TheYUnit, long TheXRange, long TheYRange);
   virtual void VScroll(WORD ScrollEvent, int ThumbPos);

};


#endif