/* Classe TDumpWindow */
#include "dump.h"
#include "defines.h"

#include <stdio.h>
#include <string.h>

#define max(a,b)(((a) >(b)) ?(a) :(b))
#define min(a,b)(((a) <(b)) ?(a) :(b))
#define abs(a)  (((a) >= 0)  ?(a) :-(a))

// memoria RAM 
extern unsigned char huge RAM[65536];

//--------------Dialogs per Fill, Goto, ...------------------------------

// Fill

TFillDialog::TFillDialog(PTWindowsObject AParent)
	:TDialog(AParent, ID_FILLMEMORY)
{
}

void TFillDialog::WMCommand(RTMessage msg)
{
 char buffer[10];
 unsigned int StartAdd, EndAdd;
 unsigned char Value;

 if(msg.WP.Lo) 
    // se il messaggio arriva da un controllo:
    if(msg.WParam == IDOK)
       {
	SendDlgItemMsg(ID_FILLFROM, WM_GETTEXT, 9, (LPARAM)buffer);
	StartAdd = (unsigned int)strtol(buffer, NULL, 16);
	SendDlgItemMsg(ID_FILLTO, WM_GETTEXT, 9, (LPARAM)buffer);
	EndAdd = (unsigned int)strtol(buffer, NULL, 16);
	SendDlgItemMsg(ID_FILLVAL, WM_GETTEXT, 9, (LPARAM)buffer);
	Value = (unsigned char)strtol(buffer, NULL, 16);

	if(StartAdd<=EndAdd)
             {
		unsigned int i;

		for(i=StartAdd; i<=EndAdd; i++)
                     RAM[i] = Value; 
	     }
	else
             {
	      MessageBox(HWindow, "End address is lower than start address.", NULL, MB_OK | MB_ICONEXCLAMATION);
	      return;  // esce senza processare il tasto OK
             }
       }

 TDialog::WMCommand(msg);
}

// Copy

TCopyDialog::TCopyDialog(PTWindowsObject AParent)
	:TDialog(AParent, ID_COPYMEMORY)    
{
}

void TCopyDialog::WMCommand(RTMessage msg)
{
 char buffer[10];
 unsigned int StartAdd, EndAdd;
 unsigned int Destination;

 if(msg.WP.Lo) 
    // se il messaggio arriva da un controllo:
    if(msg.WParam == IDOK)
       {
        SendDlgItemMsg(ID_COPYFROM, WM_GETTEXT, 9, (LPARAM)buffer);
	StartAdd = (unsigned int)strtol(buffer, NULL, 16);
	SendDlgItemMsg(ID_COPYTO, WM_GETTEXT, 9, (LPARAM)buffer);
	EndAdd = (unsigned int)strtol(buffer, NULL, 16);
	SendDlgItemMsg(ID_COPYDEST, WM_GETTEXT, 9, (LPARAM)buffer);
	Destination = (unsigned char)strtol(buffer, NULL, 16);

	if(StartAdd<=EndAdd)
             {
	      long i;
	      unsigned int n = EndAdd-StartAdd;

	      if (Destination < StartAdd)
		 {
		  for(i=0; i<=n; i++)
                     RAM[Destination + i] = RAM[StartAdd+i];
		 }
	      else
		 {
		  for(i=n; i>=0; i--)
                     RAM[Destination + i] = RAM[StartAdd+i];
		 }
	     }
	else
             {
	      MessageBox(HWindow, "End address is lower than start address.", NULL, MB_OK | MB_ICONEXCLAMATION);
	      return;  // esce senza processare il tasto OK
	     }
       }  

 TDialog::WMCommand(msg);
}


// Find
TFindDialog::TFindDialog(PTWindowsObject AParent, unsigned int *address)
	:TDialog(AParent, ID_FINDSTRING)
{
 destination = address;
}

void TFindDialog::SetupWindow()
{
 SendDlgItemMessage(HWindow, ID_WHOLEMEMORY, BM_SETCHECK, 1, 0L);
}

void TFindDialog::WMCommand(RTMessage msg)
{
 char buffer[255];
 unsigned int StartAdd, EndAdd;

 if(msg.WP.Lo) 
    // se il messaggio arriva da un controllo:
    if(msg.WParam == IDOK)
       {
	unsigned long i;
	unsigned int j,l;
        BOOL found;
	int CampoRicerca;

        CampoRicerca = SendDlgItemMessage(HWindow, ID_WHOLEMEMORY, BM_GETCHECK, 0, 0L);
	if (CampoRicerca)
	   {
	    StartAdd = 0;
            EndAdd = 0xFFFF;
	   }
	else
           {
 	    SendDlgItemMsg(ID_STARTAREA, WM_GETTEXT, 9, (LPARAM)buffer);
	    StartAdd = (unsigned int)strtol(buffer, NULL, 16);
	    SendDlgItemMsg(ID_ENDAREA, WM_GETTEXT, 9, (LPARAM)buffer);
	    EndAdd = (unsigned int)strtol(buffer, NULL, 16);
	   }
	SendDlgItemMsg(ID_STRING_TO_FIND, WM_GETTEXT, 254, (LPARAM)buffer);
	 // 'buffer' contiene la stringa da cercare
        i=StartAdd;
	found = 0;
        l=strlen(buffer);
	while ((i<=EndAdd) && (!found))
	    {
             j=0;
	     while(1)
		{
		 if (j==l)
		    {
		     found = 1;
                     break;
		    }
		 if (RAM[i+j]!=buffer[j])
		     break;
                 j++;
		}
             i++;
	    }
	if (found)
	    *destination = i;
        else
	    MessageBox(HWindow, "String not found", "Search result", MB_OK | MB_ICONEXCLAMATION);
       }
 TDialog::WMCommand(msg);
}



// Goto
 TGotoDialog::TGotoDialog(PTWindowsObject AParent, unsigned int *address)
	:TDialog(AParent, ID_GOTO)
 {
  char buffer[10];

  destination = address;
  sprintf(buffer, "%04X", *destination);
  SendDlgItemMsg(ID_GOTOADDRESS, WM_SETTEXT, 0, (LPARAM)buffer);
 }

void TGotoDialog::WMCommand(RTMessage msg)
{
 char buffer[10];

 if(msg.WP.Lo) 
    // se il messaggio arriva da un controllo:
    if(msg.WParam == IDOK)
       {
	SendDlgItemMsg(ID_GOTOADDRESS, WM_GETTEXT, 9, (LPARAM)buffer);
	*destination = (unsigned int)strtol(buffer, NULL, 16);
       }
 TDialog::WMCommand(msg);
}


//---------------finestra di dump-----------------------------------------

TDumpWindow::TDumpWindow(PTWindowsObject AParent, TDumpWindow **Me)
      : TWindow(AParent, "Memory")
{
 Myself = Me;
 Attr.Style |= (WS_VSCROLL | WS_HSCROLL);
 PopupMenu = LoadMenu(GetApplication()->hInstance, MAKEINTRESOURCE(POPUP_DUMP) );

 // I valori sono solo approssimati. Saranno messi giusti in seguito 
 Scroller = new TScroller(this, 10, 20, 70, 0x1000 );
 Scroller->YLine = 1;
 Scroller->AutoOrg = FALSE;
}

TDumpWindow::~TDumpWindow()
{
 *Myself = NULL;
 DestroyMenu(PopupMenu);
}

LPSTR TDumpWindow::GetClassName()
{
 return("DumpWindow");
}


// Assegna l'icona della finestra
void TDumpWindow::GetWindowClass(WNDCLASS& AWndClass)
{
  TWindow::GetWindowClass(AWndClass);
  AWndClass.hIcon = LoadIcon(GetApplication()->hInstance, "ICONA_DUMP");
}

// Modifica il menu della finestra MDI
void TDumpWindow::ActivationResponse(WORD Activated, BOOL IsIconified)
{
 HWND handle;
 HMENU hm;

 TWindow::ActivationResponse(Activated, IsIconified);
 handle = GetApplication()->MainWindow->HWindow;
 hm = GetMenu(handle);
 if(Activated)
     {
//menu File
      EnableMenuItem(hm, CM_FILESAVE,    MF_BYCOMMAND | MF_GRAYED);
      EnableMenuItem(hm, CM_FILESAVEAS,  MF_BYCOMMAND | MF_GRAYED);
//menu Edit
      EnableMenuItem(hm, CM_EDITUNDO,    MF_BYCOMMAND | MF_GRAYED);
      EnableMenuItem(hm, CM_EDITCUT,     MF_BYCOMMAND | MF_GRAYED);
      EnableMenuItem(hm, CM_EDITCOPY,    MF_BYCOMMAND | MF_GRAYED);
      EnableMenuItem(hm, CM_EDITPASTE,   MF_BYCOMMAND | MF_GRAYED);
      EnableMenuItem(hm, CM_EDITDELETE,  MF_BYCOMMAND | MF_GRAYED);
      EnableMenuItem(hm, CM_EDITCLEAR,   MF_BYCOMMAND | MF_GRAYED);
//menu Search
      EnableMenuItem(hm, CM_EDITFIND,    MF_BYCOMMAND | MF_GRAYED);
      EnableMenuItem(hm, CM_EDITREPLACE, MF_BYCOMMAND | MF_GRAYED);
      EnableMenuItem(hm, CM_EDITFINDNEXT,MF_BYCOMMAND | MF_GRAYED);
//menu Assembler
      EnableMenuItem(hm, MENU_ASSEMBLER_ASSEMBLE, MF_BYCOMMAND | MF_GRAYED);
      EnableMenuItem(hm, MENU_ASSEMBLER_BUILDALL, MF_BYCOMMAND | MF_GRAYED);
     }
 else
     {
//menu File
      EnableMenuItem(hm, CM_FILESAVE,    MF_BYCOMMAND | MF_ENABLED);
      EnableMenuItem(hm, CM_FILESAVEAS,  MF_BYCOMMAND | MF_ENABLED);
//menu Edit
      EnableMenuItem(hm, CM_EDITUNDO,    MF_BYCOMMAND | MF_ENABLED);
      EnableMenuItem(hm, CM_EDITCUT,     MF_BYCOMMAND | MF_ENABLED);
      EnableMenuItem(hm, CM_EDITCOPY,    MF_BYCOMMAND | MF_ENABLED);
      EnableMenuItem(hm, CM_EDITPASTE,   MF_BYCOMMAND | MF_ENABLED);
      EnableMenuItem(hm, CM_EDITDELETE,  MF_BYCOMMAND | MF_ENABLED);
      EnableMenuItem(hm, CM_EDITCLEAR,   MF_BYCOMMAND | MF_ENABLED);
//menu Search
      EnableMenuItem(hm, CM_EDITFIND,    MF_BYCOMMAND | MF_ENABLED);
      EnableMenuItem(hm, CM_EDITREPLACE, MF_BYCOMMAND | MF_ENABLED);
      EnableMenuItem(hm, CM_EDITFINDNEXT,MF_BYCOMMAND | MF_ENABLED);
//menu Assembler
      EnableMenuItem(hm, MENU_ASSEMBLER_ASSEMBLE, MF_BYCOMMAND | MF_ENABLED);
      EnableMenuItem(hm, MENU_ASSEMBLER_BUILDALL, MF_BYCOMMAND | MF_ENABLED);
     }
 DrawMenuBar(handle);
}

void TDumpWindow::Paint(HDC PaintDC, PAINTSTRUCT _FAR &)
{
 int y=0;
 unsigned int a;
 int i, pos;
 char c;
 char linea[100];
 HFONT hfont;
 RECT Area;
 int nlinee, larghezza, ncolonne;
 TEXTMETRIC tm;

 //Provvisoriamente uso sempre lo stesso font.

 hfont = (HFONT) GetStockObject(ANSI_FIXED_FONT);
 //hfont = (HFONT) GetStockObject(OEM_FIXED_FONT);
 DeleteObject(SelectObject(PaintDC, hfont));

 // Cominciamo a mettere a posto gli scroller, se per caso
 // il font e' cambiato o se siamo alla prima inizializzazione.

 GetTextMetrics(PaintDC, &tm);
 Scroller->SetUnits(tm.tmAveCharWidth, tm.tmHeight);
 
 // Calcola il numero di linee e di colonne da stampare 
 GetClientRect(HWindow, &Area);
 nlinee = (Area.bottom-Area.top)/tm.tmHeight +1;
 larghezza = (Area.right-Area.left)/tm.tmAveCharWidth +1;
 ncolonne = min(larghezza,74-Scroller->XPos);

 while ( y<nlinee )
    {
     a=(Scroller->YPos+y)*16;
     sprintf(linea, "%04X> ", a);
     for(i=0, pos=6; i<=15; i++)
	{
	 sprintf(linea+pos, "%02X ", RAM[a+i]);
	 pos+=3;
	 if(i==7)
	    {
	     sprintf(linea+pos, "  ");
             pos+=2;
	    }
	}
     sprintf(linea+pos,"  ");
     pos+=2;

     for(i=0; i<=15; i++)
	{
         c=RAM[a+i];
	 sprintf(linea+(pos++), "%c", c>=0x20 ? c : '.' );
        }

     *(linea+pos)=0;

     TextOut(PaintDC, 0, y*tm.tmHeight, linea+Scroller->XPos, ncolonne );
     y++;
    }
}

// Aziona il menu pop-up
void TDumpWindow::WMRButtonDown(RTMessage msg)
{
 POINT pt;

 pt.x = LOWORD(msg.LParam);
 pt.y = HIWORD(msg.LParam);
 ClientToScreen(HWindow, &pt);

 TrackPopupMenu(GetSubMenu(PopupMenu, 0), TPM_CENTERALIGN|TPM_RIGHTBUTTON, pt.x, pt.y, 0, HWindow, NULL);
}

//Comandi del menu pop-up
void TDumpWindow::GoTo(RTMessage)
{
 unsigned int dest;

 dest = Scroller->YPos *16;
 GetApplication()->ExecDialog(new TGotoDialog(this, &dest));
 Scroller->ScrollTo(Scroller->XPos, dest/16);
}

void TDumpWindow::Find(RTMessage)
{
 unsigned int dest;

 dest = Scroller->YPos *16;
 GetApplication()->ExecDialog(new TFindDialog(this, &dest));
 Scroller->ScrollTo(Scroller->XPos, dest/16);
}

void TDumpWindow::Fill(RTMessage)
{
 GetApplication()->ExecDialog(new TFillDialog(this) );
 SendMessage(Parent->HWindow, WM_USER + REFRESH_ALL , 0, 0L);
}

void TDumpWindow::Copy(RTMessage)
{
 GetApplication()->ExecDialog(new TCopyDialog(this) );
 SendMessage(Parent->HWindow, WM_USER + REFRESH_ALL , 0, 0L);
}