#ifndef __DUMP__
#define __DUMP__

#include <owl.h>
#include <window.h>
#include <listbox.h>
#include "defines.h"
#include "usermsg.h"

//Dialogs per Find, Goto, ...
_CLASSDEF(TFillDialog)
class TFillDialog : public TDialog
{
 public:
  TFillDialog(PTWindowsObject AParent);
  virtual void WMCommand(RTMessage);
};

_CLASSDEF(TCopyDialog)
class TCopyDialog : public TDialog
{
 public:
  TCopyDialog(PTWindowsObject AParent);
  virtual void WMCommand(RTMessage);
};


_CLASSDEF(TGotoDialog)
class TGotoDialog : public TDialog
{
 private:
  unsigned int *destination;
   
 public:
  TGotoDialog(PTWindowsObject AParent, unsigned int *address);
  virtual void WMCommand(RTMessage);

};

_CLASSDEF(TFindDialog)
class TFindDialog : public TDialog
{
 private:
  unsigned int *destination;
   
 public:
  TFindDialog(PTWindowsObject AParent, unsigned int *address);
  virtual void WMCommand(RTMessage);
  virtual void SetupWindow();

};


//------------------------------------------------------//
// Finestra di dump della RAM

_CLASSDEF (TDumpWindow)
class TDumpWindow : public TWindow
{
 private:
    TDumpWindow **Myself;
    HMENU PopupMenu;
 public:
    TDumpWindow(PTWindowsObject AParent, TDumpWindow **Me);
    ~TDumpWindow();
    virtual LPSTR GetClassName();
    virtual void GetWindowClass(WNDCLASS &);
    virtual void ActivationResponse(WORD, BOOL);
    virtual void Paint(HDC, PAINTSTRUCT _FAR &);

    virtual void WMRButtonDown(RTMessage) = [WM_FIRST + WM_RBUTTONDOWN];
    virtual void Find(RTMessage) = [CM_FIRST + POPUP_DUMP_FIND];
    virtual void GoTo(RTMessage) = [CM_FIRST + POPUP_DUMP_GOTO];
    virtual void Fill(RTMessage) = [CM_FIRST + POPUP_DUMP_FILL];
    virtual void Copy(RTMessage) = [CM_FIRST + POPUP_DUMP_COPY];
};

#endif