#ifndef __MAINWIN_H__
#define __MAINWIN_H__

#include <owl.h>
#include <window.h>
#include <mdi.h>
#include <listbox.h>

// Classe della finestra principale
class TMyMDIFrame : public TMDIFrame {
public:
  WORD ChildNum;
    
  // Finestre:
     
  TMessageWindow *Messages;     // Messaggi
  TProjectWindow *Project;      // Progetto
  TDumpWindow *Dump;            // Dump della RAM
  TDisassembler *Disasm;        // Disassemblato del programma oggetto
  TRegisterWindow *Registers;   // Registri del microprocessore

  T6502 Processor;

  TMyMDIFrame(LPSTR ATitle, int MenuID);
  virtual PTWindowsObject CreateChild();
  virtual LPSTR GetClassName();
  virtual void GetWindowClass(WNDCLASS &);
  virtual void OpenFile(RTMessage)= [CM_FIRST + CM_MDIFILEOPEN];
  virtual void SetupWindow();

  virtual void FindFile(RTMessage) = [WM_USER + FIND_FILE];
  virtual void Refresh();

  virtual void MenuWindowProject(RTMessage) = [CM_FIRST + CM_PROGETTO];
  virtual void MenuWindowMessages(RTMessage) = [CM_FIRST + CM_MESSAGGI];
  virtual void MenuWindowDump(RTMessage) = [CM_FIRST + MENU_WINDOW_DUMP];
  virtual void MenuWindowRegisters(RTMessage) = [CM_FIRST + MENU_WINDOW_REGISTERS];
  virtual void MenuWindowObject(RTMessage) = [CM_FIRST + MENU_WINDOW_OBJECT];

  virtual void MenuRunGo(RTMessage) = [CM_FIRST + MENU_RUN_GO];
  virtual void MenuRunStep(RTMessage) = [CM_FIRST + MENU_RUN_STEP];
  virtual void MenuRunReset(RTMessage) = [CM_FIRST + MENU_RUN_RESET];

  virtual void MenuProjectNew(RTMessage) = [CM_FIRST + MENU_PROJECT_NEW];
  virtual void MenuProjectOpen(RTMessage) = [CM_FIRST + MENU_PROJECT_OPEN];
  virtual void MenuProjectClose(RTMessage) = [CM_FIRST + MENU_PROJECT_CLOSE];
  virtual void MenuProjectAdd(RTMessage) = [CM_FIRST + MENU_PROJECT_ADD];
  virtual void MenuProjectRemove(RTMessage) = [CM_FIRST + MENU_PROJECT_REMOVE];

  virtual void MenuOptionsAssembler(RTMessage) = [CM_FIRST + MENU_OPTIONS_ASSEMBLER];
  virtual void MenuOptionsDebugger(RTMessage) = [CM_FIRST + MENU_OPTIONS_DEBUGGER];

  virtual void MenuHelpAbout(RTMessage) = [CM_FIRST + MENU_HELP_ABOUT];

};
#endif