/* Classe TMessageWindow */
#include <stdio.h>
#include "messages.h"
#include "defines.h"
#include "usermsg.h"

TMessageList::TMessageList(PTWindowsObject AParent, int AnId, int X, int Y,
		           int W, int H, PTModule AModule = NULL)
	     : TListBox(AParent, AnId, X, Y, W, H, AModule)
{
  Attr.Style = WS_CHILD | WS_VISIBLE | WS_GROUP | WS_TABSTOP | WS_VSCROLL
	      | LBS_NOTIFY | LBS_NOINTEGRALHEIGHT;
}


TMessageWindow::TMessageWindow(PTWindowsObject AParent)
      : TWindow(AParent, "Messages")
{
 Elenco = new TMessageList(this, ID_MESSAGELIST, 1,1,1,1);
 FirstMessageItem = LastMessageItem = NULL;
}

TMessageWindow::~TMessageWindow()
{
 delete Elenco;
}

void TMessageWindow::SetupWindow()
{
 HFONT f;

 TWindow::SetupWindow();
 f = CreateFont(-12, 0, 0, 0, FW_BOLD, 0, 0, 0, 0, 0, 0, 0, 0, "MS Sans Serif");
 SendMessage(Elenco->HWindow, WM_SETFONT, (WPARAM)f, (LPARAM) MAKELONG((WORD) TRUE, 0) );
}

LPSTR TMessageWindow::GetClassName()
{
 return("MessageWindow");
}

// Assegna l'icona della finestra
void TMessageWindow::GetWindowClass(WNDCLASS& AWndClass)
{
  TWindow::GetWindowClass(AWndClass);
  AWndClass.hIcon = LoadIcon(GetApplication()->hInstance, "ICONA_MESSAGGI");
}



//  La finestra dei messaggi non deve distruggersi ma solo nascondersi,
//  altrimenti perdiamo i messaggi !!!
void TMessageWindow::WMClose(RTMessage)
{
 Show(SW_HIDE); //nascondo la finestra
}

void TMessageWindow::WMSize(RTMessage msg)
{
 TWindow::WMSize(msg);
 if (msg.WParam != SIZE_MINIMIZED)
      MoveWindow(Elenco->HWindow, 0, 0, msg.LP.Lo, msg.LP.Hi, TRUE);
}

void TMessageWindow::Cancella()
{
 message_item *pt;

 Elenco->ClearList();
 while(FirstMessageItem)
    {
     pt = FirstMessageItem;
     FirstMessageItem = FirstMessageItem->next;
     free(pt);
    }
 LastMessageItem = NULL;
}

void TMessageWindow::AddMessage(RTMessage msg)
{
 message_item *pt;

// pt = (message_item *)malloc(sizeof(message_item));

 pt= (message_item *)(msg.LParam);
 pt->next = NULL;
 Elenco->AddString((LPSTR)pt->message_body );

 if(!FirstMessageItem)
     FirstMessageItem = pt;

 if(LastMessageItem)
    LastMessageItem->next = pt;
 LastMessageItem = pt;
}

void TMessageWindow::WMCommand(RTMessage msg)
{
 message_item *pt = FirstMessageItem;
 int i,n;
  
 if(msg.WP.Lo)
    // se il messaggio arriva da un controllo:
    if(msg.WParam==ID_MESSAGELIST)
       {
	if (msg.LP.Hi == LBN_DBLCLK)
	    {
             n= Elenco->GetSelIndex();
	     //Cerca il messaggio corrispondente
	     for(i=0; i<n; i++)
		 {
                  if(pt)
		     pt=pt->next;
		  else
                     break;
		 }
	     if(pt)
	        {   
		 if(pt->message_file_name[0])
                     {
		      SendMessage(Parent->HWindow, WM_USER + EDIT_BY_NAME,
		           (WPARAM)pt->message_line_number,
		           (LPARAM)pt->message_file_name );
                     }
		}  
	    }
       }

 TWindow::WMCommand(msg);
}
