/* Classe TOptionsWindow */

#include <stdio.h>
#include <dialog.h>
#include "options.h"

#include "defines.h"

// Opzioni del compilatore (che e' scritto in C, non in C++... )
extern char op_a, op_b, op_c, op_e, op_g, op_s, op_w;

//file .INI
extern char IniFile[];

TOptionsWindow::TOptionsWindow(PTWindowsObject AParent)
      : TDialog(AParent, ID_OPTIONWINDOW)
{
}

void TOptionsWindow::SetupWindow()
{
 TDialog::SetupWindow();
 SpuntaOpzione(ID_OPWARN,op_w);
 SpuntaOpzione(ID_OPSYM,op_s);
 SpuntaOpzione(ID_OPCASE,op_c);
}

LPSTR TOptionsWindow::GetClassName()
{
 return("OptionsWindow");
}

// Assegna l'icona della finestra delle opzioni
void TOptionsWindow::GetWindowClass(WNDCLASS& AWndClass)
{
  TDialog::GetWindowClass(AWndClass);
  AWndClass.hIcon = LoadIcon(GetApplication()->hInstance, "ICONA_APPL");
}

// Cambia le opzioni
void TOptionsWindow::WMCommand(RTMessage msg)
{
 char buf[255];

 if(msg.WP.Lo)
    // se il messaggio arriva da un controllo:
    switch(msg.WParam)
       {
	case ID_OPWARN :   // Warning  on/off
	     op_w = (char)SendDlgItemMsg(ID_OPWARN, BM_GETCHECK, 0, 0L);
             sprintf(buf, "%d", op_w);
	     WritePrivateProfileString("COMPILER", "Warnings", buf, IniFile);
	     break;

	case ID_OPSYM :    // Genera la symbol table?
	     op_s = (char)SendDlgItemMsg(ID_OPSYM, BM_GETCHECK, 0, 0L);
	     sprintf(buf, "%d", op_s);
	     WritePrivateProfileString("COMPILER", "SymbolTable", buf, IniFile);
	     break;

	case ID_OPCASE :   // Case sensitivity
	     op_c = (char)SendDlgItemMsg(ID_OPCASE, BM_GETCHECK, 0, 0L);
	     sprintf(buf, "%d", op_c);
	     WritePrivateProfileString("COMPILER", "CaseSensitivity", buf, IniFile);
	     break;
       }

 TDialog::WMCommand(msg);

}


//
void TOptionsWindow::SpuntaOpzione(WORD id, char op)
{
 if(op)
   SendDlgItemMsg(id, BM_SETCHECK, BF_CHECKED, 0);
 else
   SendDlgItemMsg(id, BM_SETCHECK, BF_UNCHECKED, 0);
}

