// classe del microprocessore

#ifndef __PROCESSORE__
#define __PROCESSORE__

_CLASSDEF (T6502)

class T6502 
{
 public:
    unsigned char A,X,Y,SP;    /* registri */
    unsigned int PC;           /* Program Counter */

    union status{              /* Status Register: */
     	         struct bit{
			    char C  :1; /* carry */
			    char Z  :1; /* risultato ==0 */
			    char I  :1; /* interrupt */
			    char D  :1; /* modo decimale */
			    char B  :1; /* BRK flag */
			    char X  :1; /* non usato, sempre=1 */
			    char V  :1; /* overflow */
			    char N  :1; /* risultato positivo */
		           }     bit;
	         unsigned char byte;
		} SR;

// Eccezione : stop utente (ad es. in caso di stack overflow)
    int StackOverflow;

// Opzioni per il debugger
    char OrgFromCode;      //TRUE: RESTART = ORG
    unsigned int DefaultRestartAddress;  //indirizzo di restart
    char StopAfterReset;   //FALSE:dopo JMP($FFFE) riparte automaticamente
    char ResetToOrg;       //FALSE:jmp($FFFE), TRUE:jmp RESTART
    char StopOnBreak;      //TRUE: al BRK si ferma

    char ClearRegsOnReset;  //dopo un reset pulisci i registri
    char ClearStackOnReset; //   "      "      "    lo stack
    char ClearFlagsOnReset; //   "      "      "    i flags

    char CheckStackOverflow; //TRUE: manda un warning in caso di stack overflow

    int NBeforeEscape; // #istruzioni eseguite prima di controllare lo 'stop' utente

    T6502();
    int step(void);
    void reset(void);
    void NMI(void);
    void IRQ(void);

private:
    void push(unsigned char);
    unsigned char pop(void);
    void execute(unsigned char, int, unsigned int );
};





#endif