#ifndef __PROJECT__
#define __PROJECT__

#include <owl.h>
#include <window.h>
#include <mdi.h>
#include <listbox.h>
#include "messages.h"
#include "defines.h"

typedef struct t_project_file
	 {
	   char *name;
           char *path;
           struct t_project_file *next;
	 }   project_file;

// Finestra di progetto
_CLASSDEF (TProjectWindow)
class TProjectWindow : public TWindow
{
 private:
    project_file *first_project_file;
    TProjectWindow **Myself;
    TMessageWindow *Messages;
    PTListBox Elenco;
    char FileName[255];

 public:
    TProjectWindow(PTWindowsObject AParent, TProjectWindow **Myself, TMessageWindow *);
    ~TProjectWindow();
    virtual LPSTR GetClassName();
    virtual void SetupWindow();
    virtual void GetWindowClass(WNDCLASS &);
    virtual void ActivationResponse(WORD Activated, BOOL IsIconified);
    virtual void OpenSourceFile(int);
    virtual int AddString(LPSTR);
    virtual int AddString(LPSTR, int);
    virtual int DeleteSelected();
    virtual void OpenProject();
    virtual BOOL CloseProject();
    virtual BOOL Save();
    virtual BOOL SaveAs();
    virtual BOOL Write();
    virtual BOOL Read();
    virtual BOOL CanClose();
    virtual void SetName();
    virtual void Refresh();
    virtual void WMCommand(RTMessage)= [WM_FIRST + WM_COMMAND];
    virtual void Assemble(RTMessage) = [CM_FIRST + MENU_ASSEMBLER_ASSEMBLE];
    virtual void BuildAll(RTMessage) = [CM_FIRST + MENU_ASSEMBLER_BUILDALL];
    virtual void WMSize(RTMessage) = [WM_FIRST + WM_SIZE];
    virtual void WMClose(RTMessage) = [WM_FIRST + WM_CLOSE];
    virtual void MenuProjectAdd(RTMessage) = [CM_FIRST + MENU_PROJECT_ADD];
    virtual void MenuProjectRemove(RTMessage) = [CM_FIRST + MENU_PROJECT_REMOVE];
};

// Elenco dei files di progetto
_CLASSDEF (TProjectList)
class TProjectList : public TListBox
{
public:
    TProjectList( PTWindowsObject AParent, int AnId, int X, int Y,
		   int W, int H, PTModule AModule);
    virtual int AddString(char *);
};

#endif