/* Classe TRegisterWindow */

#include "register.h"
#include "defines.h"
#include <stdio.h>
#include <stdlib.h>

//Lato di un checkbox (che e' quadrato, credo).
#define LATO_CB 18

//-----------------------------------------------------------------------------------

TRegisterTextBox::TRegisterTextBox(PTWindowsObject AParent, int X, int Y,
				   int W, int H, unsigned int &Reg)
		  :TEdit(AParent, 0, "", X, Y, W, H, 5, FALSE)

{
 Registro= (unsigned int *) &Reg;
 Flag16 = TRUE;
}

TRegisterTextBox::TRegisterTextBox(PTWindowsObject AParent, int X, int Y,
				   int W, int H, unsigned char &Reg)
	          :TEdit(AParent, 0, "", X, Y, W, H, 3, FALSE)

{
 Registro = (unsigned char *)&Reg;
 Flag16 = FALSE;
}

void TRegisterTextBox::Refresh()
{
 char buffer[10];

 if(Flag16)
     sprintf(buffer, "%04X", *(unsigned int *)Registro);
 else
     sprintf(buffer, "%02X", *(unsigned char *)Registro );
 SetText(buffer);

}

void TRegisterTextBox::WriteReg()
{
 unsigned long int value;
 char buffer[10];

 GetText(buffer, 9);
 value = strtoul(buffer, NULL, 16);
 if(Flag16)
     *(unsigned int *)Registro = (unsigned int) value;
 else
     *(unsigned char *)Registro = (unsigned char)value;

}

//-----------------------------------------------------------------------------------
TRegisterCheckBox::TRegisterCheckBox(PTWindowsObject AParent, LPSTR ATitle,
 int X, int Y, TRegisterTextBox *cas, char bitpos)
	:TCheckBox(AParent, 0, "", X, Y+18+5, LATO_CB, LATO_CB, NULL)
{
 PTStatic tmp;

 Casella = cas;
 Registro =(unsigned char *)Casella->Registro;
 BitPos = bitpos;

 tmp = new TStatic(this->Parent, 0, ATitle,  X, Y, LATO_CB, 18, 3);
 tmp->Attr.Style = WS_CHILD | WS_VISIBLE | WS_GROUP | SS_CENTER;
}

void TRegisterCheckBox::Refresh()
{
 if( ((*Registro)>>BitPos) & 0x01 )
   Check();
 else
   Uncheck();
}

void TRegisterCheckBox::BMToggle(RTMessage msg)
{
 unsigned char mask = 0x01;
 unsigned char v;
 char buffer[6];

 DefWndProc(msg);
 Casella->GetText(buffer, 5);
 v = (unsigned char)strtoul(buffer, NULL, 16);
 if (GetCheck()==BF_UNCHECKED)
     v=v&( 0xFF-(mask<<BitPos) );     //AND
 else
     v=v|(mask<<BitPos);              //OR
 sprintf(buffer, "%02X", v);
 Casella->SetText(buffer);
}

//-----------------------------------------------------------------------------------

TRegisterWindow::TRegisterWindow(PTWindowsObject AParent, TRegisterWindow **Me, T6502 *Proc)
      : TWindow(AParent, "Registers")
{
 Myself = Me;
 Processore = Proc;
 PTStatic tmp;
 char FlagString[] = "C\0Z\0I\0D\0B\0X\0V\0N\0";
 int i;

 Attr.H = 220;
 Attr.W = 260;

 tmp = new TStatic(this, 0, "A",  10, 15, 25, 30, 3);
 tmp->Attr.Style = WS_CHILD | WS_VISIBLE | WS_GROUP | SS_RIGHT;
 tmp = new TStatic(this, 0, "X",  90, 15, 25, 30, 3);
 tmp->Attr.Style = WS_CHILD | WS_VISIBLE | WS_GROUP | SS_RIGHT;
 tmp = new TStatic(this, 0, "Y", 170, 15, 25, 30, 3);
 tmp->Attr.Style = WS_CHILD | WS_VISIBLE | WS_GROUP | SS_RIGHT;

 tmp = new TStatic(this, 0, "PC",  10, 55, 25, 30, 3);
 tmp->Attr.Style = WS_CHILD | WS_VISIBLE | WS_GROUP | SS_RIGHT;
 tmp = new TStatic(this, 0, "SP",  90, 55, 25, 30, 3);
 tmp->Attr.Style = WS_CHILD | WS_VISIBLE | WS_GROUP | SS_RIGHT;
 tmp = new TStatic(this, 0, "SR", 170, 55, 25, 30, 3);
 tmp->Attr.Style = WS_CHILD | WS_VISIBLE | WS_GROUP | SS_RIGHT;


 Edit_A = new TRegisterTextBox(this,  37, 10, 35, 30, Processore->A );
 Edit_X = new TRegisterTextBox(this, 117, 10, 35, 30, Processore->X );
 Edit_Y = new TRegisterTextBox(this, 197, 10, 35, 30, Processore->Y );

 Edit_PC = new TRegisterTextBox(this,  37, 50, 50, 30, Processore->PC );
 Edit_SP = new TRegisterTextBox(this, 117, 50, 35, 30, Processore->SP );
 Edit_SR = new TRegisterTextBox(this, 197, 50, 35, 30, Processore->SR.byte );

 for(i=0; i<=7; i++)
    Flags[i] = new TRegisterCheckBox(this, (FlagString +2*i), 50+LATO_CB*i, 90, Edit_SR, i);
                                                                                      
 new TButton(this, ID_RESTORE_REGS, "Restore", 30, 150, 70, 30, FALSE);
 new TButton(this, ID_CHANGE_REGS, "Change", 150, 150, 70, 30, TRUE);

}


TRegisterWindow::~TRegisterWindow()
{
 delete Edit_A;
 delete Edit_X;
 delete Edit_Y;

 delete Edit_PC;
 delete Edit_SP;
 delete Edit_SR;

 *Myself = NULL;
}

LPSTR TRegisterWindow::GetClassName()
{
 return("RegisterWindow");
}

// Assegna l'icona della finestra MDI
void TRegisterWindow::GetWindowClass(WNDCLASS& AWndClass)
{
 TWindow::GetWindowClass(AWndClass);
 AWndClass.hIcon = LoadIcon(GetApplication()->hInstance, "ICONA_REGISTRI");
}

// Aggiorna i registri
void TRegisterWindow::Refresh()
{
 int i;

 Edit_A->Refresh();
 Edit_X->Refresh();
 Edit_Y->Refresh();

 Edit_PC->Refresh();
 Edit_SP->Refresh();
 Edit_SR->Refresh();

 for (i=0; i<=7; i++)
    Flags[i]->Refresh();
}

void TRegisterWindow::Paint(HDC, PAINTSTRUCT _FAR &)
{
 Refresh();
}

void TRegisterWindow::ActivationResponse(WORD Activated, BOOL IsIconified)
{
 TWindow::ActivationResponse(Activated, IsIconified);
 if(Activated == WA_INACTIVE)
    Refresh();
}

void TRegisterWindow::UpdateRegs(RTMessage)
{
 Edit_A->WriteReg();
 Edit_X->WriteReg();
 Edit_Y->WriteReg();

 Edit_PC->WriteReg();
 Edit_SP->WriteReg();
 Edit_SR->WriteReg(); // Scrivendo SR aggiorno ovviamente anche i flag

}


void TRegisterWindow::RestoreRegs(RTMessage)
{
 Refresh();
}

void TRegisterWindow::CloseWindow()
{
 *Myself = NULL;
}