#ifndef __REGISTRI__
#define __REGISTRI__

#include <owl.h>
#include <window.h>
#include <edit.h>
#include <button.h>
#include <checkbox.h>
#include "process.h"

#define ID_RESTORE_REGS 1000
#define ID_CHANGE_REGS 1010

// Casella di testo per i registri.
_CLASSDEF (TRegisterTextBox)
class TRegisterTextBox : public TEdit
{
 private:
    BOOL Flag16;

 public:
    void *Registro;     // registro a 8 oppure 16 bit
    TRegisterTextBox(PTWindowsObject AParent, int X, int Y, int W, int H, unsigned int &Reg);
    TRegisterTextBox(PTWindowsObject AParent, int X, int Y, int W, int H, unsigned char &Reg);

    virtual void Refresh();
    void WriteReg();  //scrive nel registro un nuovo valore
};

//CheckBox per i flag
_CLASSDEF (TRegisterCheckBox)

class TRegisterCheckBox : public TCheckBox
{
 private:
   unsigned char *Registro;  //puntatore a SR
   char BitPos;              //# di bit in SR
 public:
   TRegisterTextBox *Casella;
   TRegisterCheckBox(PTWindowsObject AParent, LPSTR ATitle,
              int X, int Y, TRegisterTextBox *cas, char bitpos);
   void Refresh();   //legge il registro
   virtual void BMToggle(RTMessage) = [WM_FIRST + BM_SETCHECK];

};

// Finestra dei registri
_CLASSDEF (TProjectWindow)
class TRegisterWindow : public TWindow
{
 private:
    TRegisterWindow **Myself;
    TRegisterTextBox *Edit_A,  *Edit_X,  *Edit_Y;
    TRegisterTextBox *Edit_SP, *Edit_SR, *Edit_PC;
    TRegisterCheckBox *Flags[8];

 public:
    T6502 *Processore;

    TRegisterWindow(PTWindowsObject AParent, TRegisterWindow **Me, T6502 *Proc);
    ~TRegisterWindow();
    virtual LPSTR GetClassName();
    virtual void GetWindowClass(WNDCLASS &);
    virtual void Paint(HDC, PAINTSTRUCT _FAR &);
    virtual void ActivationResponse(WORD, BOOL);
    virtual void Refresh();
    virtual void UpdateRegs(RTMessage)=[ID_FIRST+ID_CHANGE_REGS];
    virtual void RestoreRegs(RTMessage)=[ID_FIRST+ID_RESTORE_REGS];
    virtual void CloseWindow();
};


#endif