/* Classe TStackWindow */
#include "stack.h"
#include "defines.h"

#include <stdio.h>
#include <string.h>

#define min(a,b)(((a) <(b)) ?(a) :(b))

#define TEXT_HEIGHT 20
#define TEXT_WIDTH 16

// memoria RAM 
extern unsigned char huge RAM[65536];


TStackWindow::TStackWindow(PTWindowsObject AParent, TStackWindow **Me, T6502 *Proc)
      : TWindow(AParent, "Stack")
{
 Myself = Me;
 Processore = Proc;
 Attr.Style |= (WS_VSCROLL);
 Attr.W = 100;
 Scroller = new TScroller(this, 0, TEXT_HEIGHT, 0, 1 );
 Scroller->YLine = 1;
 Scroller->AutoOrg = FALSE;
}

TStackWindow::~TStackWindow()
{
 *Myself = NULL;
}

LPSTR TStackWindow::GetClassName()
{
 return("StackWindow");
}


// Assegna l'icona della finestra
void TStackWindow::GetWindowClass(WNDCLASS& AWndClass)
{
  TWindow::GetWindowClass(AWndClass);
  AWndClass.hIcon = LoadIcon(GetApplication()->hInstance, "ICONA_STACK");
}

// Modifica il menu della finestra MDI
void TStackWindow::ActivationResponse(WORD Activated, BOOL IsIconified)
{
 HWND handle;
 HMENU hm;

 TWindow::ActivationResponse(Activated, IsIconified);
 handle = GetApplication()->MainWindow->HWindow;
 hm = GetMenu(handle);
 if(Activated)
     {
//menu File
      EnableMenuItem(hm, CM_FILESAVE,    MF_BYCOMMAND | MF_GRAYED);
      EnableMenuItem(hm, CM_FILESAVEAS,  MF_BYCOMMAND | MF_GRAYED);
//menu Edit
      EnableMenuItem(hm, CM_EDITUNDO,    MF_BYCOMMAND | MF_GRAYED);
      EnableMenuItem(hm, CM_EDITCUT,     MF_BYCOMMAND | MF_GRAYED);
      EnableMenuItem(hm, CM_EDITCOPY,    MF_BYCOMMAND | MF_GRAYED);
      EnableMenuItem(hm, CM_EDITPASTE,   MF_BYCOMMAND | MF_GRAYED);
      EnableMenuItem(hm, CM_EDITDELETE,  MF_BYCOMMAND | MF_GRAYED);
      EnableMenuItem(hm, CM_EDITCLEAR,   MF_BYCOMMAND | MF_GRAYED);
//menu Search
      EnableMenuItem(hm, CM_EDITFIND,    MF_BYCOMMAND | MF_GRAYED);
      EnableMenuItem(hm, CM_EDITREPLACE, MF_BYCOMMAND | MF_GRAYED);
      EnableMenuItem(hm, CM_EDITFINDNEXT,MF_BYCOMMAND | MF_GRAYED);
//menu Assembler
      EnableMenuItem(hm, MENU_ASSEMBLER_ASSEMBLE, MF_BYCOMMAND | MF_GRAYED);
      EnableMenuItem(hm, MENU_ASSEMBLER_BUILDALL, MF_BYCOMMAND | MF_GRAYED);
     }
 else
     {
//menu File
      EnableMenuItem(hm, CM_FILESAVE,    MF_BYCOMMAND | MF_ENABLED);
      EnableMenuItem(hm, CM_FILESAVEAS,  MF_BYCOMMAND | MF_ENABLED);
//menu Edit
      EnableMenuItem(hm, CM_EDITUNDO,    MF_BYCOMMAND | MF_ENABLED);
      EnableMenuItem(hm, CM_EDITCUT,     MF_BYCOMMAND | MF_ENABLED);
      EnableMenuItem(hm, CM_EDITCOPY,    MF_BYCOMMAND | MF_ENABLED);
      EnableMenuItem(hm, CM_EDITPASTE,   MF_BYCOMMAND | MF_ENABLED);
      EnableMenuItem(hm, CM_EDITDELETE,  MF_BYCOMMAND | MF_ENABLED);
      EnableMenuItem(hm, CM_EDITCLEAR,   MF_BYCOMMAND | MF_ENABLED);
//menu Search
      EnableMenuItem(hm, CM_EDITFIND,    MF_BYCOMMAND | MF_ENABLED);
      EnableMenuItem(hm, CM_EDITREPLACE, MF_BYCOMMAND | MF_ENABLED);
      EnableMenuItem(hm, CM_EDITFINDNEXT,MF_BYCOMMAND | MF_ENABLED);
//menu Assembler
      EnableMenuItem(hm, MENU_ASSEMBLER_ASSEMBLE, MF_BYCOMMAND | MF_ENABLED);
      EnableMenuItem(hm, MENU_ASSEMBLER_BUILDALL, MF_BYCOMMAND | MF_ENABLED);
     }
 DrawMenuBar(handle);
}

void TStackWindow::Paint(HDC PaintDC, PAINTSTRUCT _FAR &)
{
 unsigned int a, base;
 char linea[10];
 HFONT hfont;
 RECT Area;
 int nlinee, i, npos;

 // Calcola il numero di linee 
 GetClientRect(HWindow, &Area);
 nlinee = (Area.bottom-Area.top)/TEXT_HEIGHT +1;
 hfont = (HFONT) GetStockObject(ANSI_FIXED_FONT);
 DeleteObject(SelectObject(PaintDC, hfont));

 //qui in realta' sarebbe bene far diventare grigio lo scroller...
 npos = 255 - Processore->SP - nlinee;
 if(npos>0)
      Scroller->SetRange(0, 255-Processore->SP);

 base = 0x100+Scroller->YPos+Processore->SP+1;
 for(i=0; i<=nlinee; i++)
    {
     a = base+i;
     if (a<0x200)   //metodo scemo
        {
         sprintf(linea, "%04X> %02X", a, RAM[a]);
	 TextOut(PaintDC, 0, i*TEXT_HEIGHT, linea, strlen(linea) );
        }
    }
  
}
