#ifndef __WATCH__
#define __WATCH__

#include <owl.h>
#include <window.h>
#include <listbox.h>
#include <scroller.h>
#include "defines.h"

//Elemento della watch list
typedef struct t_watch_item{
			    char *expr;
			    unsigned int loc;
			    unsigned char result;
			    struct t_watch_item *next;
			   }   watch_item;

// Dialog per inserire un'espressione
_CLASSDEF(TAddDialog)
class TAddDialog : public TDialog
{
 private:
  char *Destination;
   
 public:
  TAddDialog(PTWindowsObject AParent, char *buf);
  virtual void SetupWindow();
  virtual void WMCommand(RTMessage);
  virtual void CloseWindow(int n);
};

// Watch list
_CLASSDEF (TWatchList)
class TWatchList : public TListBox
{
public:
    TWatchList( PTWindowsObject AParent, int AnId, int X, int Y,
		   int W, int H, PTModule AModule);
};


// finestra di watch per le variabili
_CLASSDEF (TWatchWindow)
class TWatchWindow : public TWindow
{
 private:
    TWatchWindow **Myself;
    TWatchList *Elenco;
    watch_item *first_watch_item;

 public:
    TWatchWindow(PTWindowsObject AParent, TWatchWindow **Me);
    ~TWatchWindow();
    virtual void SetupWindow();
    virtual LPSTR GetClassName();
    virtual void GetWindowClass(WNDCLASS &);
    virtual void ActivationResponse(WORD, BOOL);
    virtual void WMSize(RTMessage);

    virtual void AddExpression(char *);
    virtual void RemoveExpression();
    virtual void ClearWatchList();

    virtual void WMCommand(RTMessage msg);
    virtual void RicalcolaTutto();

    virtual void AddWatch(RTMessage) = [CM_FIRST + MENU_DEBUG_ADD];
    virtual void RemoveWatch(RTMessage) = [CM_FIRST + MENU_DEBUG_REMOVEWATCH];
    virtual void RemoveAllWatches(RTMessage) = [CM_FIRST + MENU_DEBUG_REMOVE_ALL_WATCHES];
};

#endif