// I/O per la versione Windows
#include <stdarg.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <windows.h>
#include "usermsg.h"
#include "defines.h"
#include "msgstruc.h"

HWND FinestraMessaggi;
HWND FinestraPrompt;

char buffer[255];
char msgbuffer[255];    /*  per io_message()  */

// Bisogna rispettare i carriage return. Per questo inseriamo una
// nuova stringa solo dopo '\n' usando una funzione separata, io_message_nl().

void io_message(const char *format, ...)
{
   va_list argptr;

 // Aggiungo in coda il testo...
   va_start(argptr, format);
   vsprintf( (msgbuffer + strlen(msgbuffer)), format, argptr);
   va_end(argptr);
}

void io_message_nl(char *filename, int line)
{
 message_item *pt;

 pt = (message_item *)malloc(sizeof(message_item));

// SendMessage(FinestraMessaggi, WM_USER + ADD_MESSAGE,
//              0, (LPARAM)(LPCSTR)msgbuffer );

 strcpy(pt->message_body, msgbuffer);

 if(filename!=NULL) //il nome deve esistere, non vuoto.
  {			     //altrimenti ogni tanto si pianta. Come mai? Boh.
   if (*filename!='\0')
     {
      strcpy(pt->message_file_name, filename);
      pt->message_line_number = line;
     }
  }
 else
   {
    pt->message_file_name[0] = 0;
    pt->message_line_number = 0;
   } 
 SendMessage(FinestraMessaggi, WM_USER + ADD_MESSAGE,
              0, (LPARAM)(LPCSTR)pt );
 *msgbuffer = 0;
}

void io_echo(const char *format, ...)
{
   va_list argptr;

   va_start(argptr, format);
   vsprintf(buffer, format, argptr);
   va_end(argptr);

   SendDlgItemMessage(FinestraMessaggi, ID_MESSAGELISTBOX,
		      LB_ADDSTRING, 0, (LPARAM)(LPCSTR) buffer );
}

void io_symecho(const char *format, ...)
{
   va_list argptr;

   va_start(argptr, format);
   vsprintf(buffer, format, argptr);
   va_end(argptr);

   SendDlgItemMessage(FinestraMessaggi, ID_MESSAGELISTBOX,
		      LB_ADDSTRING, 0, (LPARAM)(LPCSTR) buffer );
}

#pragma argsused
void io_prompt(const char *format, ...)
{
 // il prompt lo eliminiamo del tutto.
}

void io_status(const char *format, ...)
{

   va_list argptr;

   va_start(argptr, format);
   vsprintf(buffer, format, argptr);
   va_end(argptr);


   SendDlgItemMessage(FinestraPrompt, ID_PROMPTTEXT,
   		      WM_SETTEXT, 0, (LPARAM)(LPCSTR) buffer);		      
}
