//Parser e scanner per le espressioni di watch
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>

#define TRUE 1
#define FALSE 0
/* token */

#define TOKEN_ERROR    0
#define TOKEN_INT    260
#define TOKEN_ID     270
#define TOKEN_EOF   1000

/* errori aritmetici */
#define E_NOERR        0
#define E_SYNTAX     100	
#define E_DIVZ	     110
#define E_DOMAIN     120
#define E_NOTFOUND   130

// Funzione di ricerca nella symbol table
extern char get_watch_symbol(char *s, unsigned int *val);

//prototipi parser
int  e(void), e1(void), t(void), t1(void), f(void);
int exp_eval(char *, unsigned int *);

//prototipi scanner
int zzlex(void);

//---------------------------scanner-------------------
char zztext[255];
char *zzpt;
int zzend; // carattere corrente in uscita

//stati dello scanner
enum { S_ERR, S_START, S_ID, S_INT, S_ACCEPT };

int zzlex()
{
 int stato;

 zzend = 0;
 stato = S_START;
 if(*zzpt=='\0') return(TOKEN_ERROR); //unexpected end of line
 while (stato !=S_ERR)
      switch(stato)
	  {
	   case S_START:
	       switch(*zzpt)
		 {
		  case '+':
		  case '-':
		  case '*':
		  case '/':
		  case '(':
		  case ')':
		     zztext[0] = *zzpt;
		     zztext[1]='\0';
		     stato = S_START;
		     return(*(zzpt++));
		  case ' ':
		     zzpt++;
		     break;
		  default:
		     if ( isdigit(*zzpt))
			{
			 zztext[zzend++]=*zzpt;
			 stato = S_INT;
			 zzpt++;
			}
		     else if( isalpha(*zzpt))
			{
			 zztext[zzend++]=*zzpt;
			 stato = S_ID;
			 zzpt++;
			}
		     else
			 stato = S_ERR;
		 }
	       break;

	   case S_ID:
  //un identificatore puo' comprendere anche @ e : al suo interno
	       if( isalnum(*zzpt)  || (*zzpt=='@') || (*zzpt == ':'))
		     {
		      zztext[zzend++]=*zzpt;
		      zzpt++;
		     }
	       else
		    {
		     zztext[zzend++]='\0';
		     stato = S_START;
		     return(TOKEN_ID);
		    }
	       break;

	   case S_INT:
	       if( isdigit(*zzpt) )
		     {
		      zztext[zzend++]=*zzpt;
		      zzpt++;
		     }
	       else
		    {
		     zztext[zzend++]='\0';
		     stato = S_START;
		     return(TOKEN_INT);
		    }
	       break;
	  }
 return(TOKEN_EOF);
}



//------------------parser----------------------------------
int zztoken;
unsigned int zzval;
int zzerrore;


int e()
{
 return(t() && e1());
}

int e1()
{
 unsigned int lval;

 if(zztoken=='+')
       {
	lval = zzval;
	zztoken = zzlex();
	if(t())
	 {
	  zzval +=lval;
	  return(e1());
	 }
	else return(FALSE);
       }
 if(zztoken=='-')
       {
	lval = zzval;
	zztoken = zzlex();
	if(t())
	 {
	  zzval = lval-zzval;
	  return(e1());
	 }
	else return(FALSE);
       }
 return(TRUE);
}

int t()
{
 return(f() && t1());
}

int t1()
{
 unsigned int lval;

 if(zztoken=='*')
       {
	lval = zzval;
	zztoken = zzlex();
	if (f())
	   {
	    zzval*=lval;
	    return t1();
	   }
	else return(FALSE);
       }

 if(zztoken=='/')
       {
	lval = zzval;
	zztoken = zzlex();
	if (f())
	   {
	    if ( zzval== 0)
		  zzerrore = E_DIVZ;
	    else
		 {
		  zzval = lval/zzval;
		 }
	    return t1();
	   }
	else return(FALSE);
       }
 return(TRUE);
}

int f()
{
 switch(zztoken)
 {
  case TOKEN_INT:
       zzval = atol(zztext);
       zztoken = zzlex();
       return (TRUE);

  case TOKEN_ID:     //provvisoriamente prende il codice ASCII
       if( get_watch_symbol(zztext, &zzval) )
          {
	   zztoken = zzlex();
	   return (TRUE);
	  }
       else
	  {
	   zzerrore = E_NOTFOUND;
           zztoken = zzlex();
           return(TRUE);
	  }

  case '(':
       zztoken=zzlex();
       if(e()&&(zztoken==')'))
	   {
	    zztoken = zzlex();
	    return(TRUE);
	   }
       break;

  case '-':
       zztoken=zzlex();
       if (f())
	  {
	   zzval = -zzval;
	   return(TRUE);
	  }
       break;
 }
 return(FALSE);
}


int exp_eval(char *expr, unsigned int *valore)
{
 zzpt = expr;
 zztoken = zzlex();
 zzerrore = E_NOERR;

 if(!e())
   {
    *valore = E_SYNTAX;
    return(FALSE);
   }
 else
   if(zzerrore==E_NOERR)
        {
         *valore = zzval;
         return(TRUE);
        }
   else
	{
	 *valore = zzerrore;
         return(FALSE);
        }
}


/* La versione DOS funziona cosi' :

void main()
{
 char buffer[100];
 unsigned int v;

 gets(buffer);
 buffer[strlen(buffer)]='\0';

 if(exp_eval(buffer, &v))
   {
    printf("%u\n",v);
   }
}

*/