/*

Just some example menus. File...->Quit is the only thing that works.

*/


#include "screen.h"
#include "menu.h"
#include "cbm.h"


unsigned char MainMenu();
unsigned char FileMenu();
unsigned char SectionMenu();


void main(void) {
  InitScreen("Simple example menu                     ", COLOR_BLACK, COLOR_BLACK, COLOR_LIGHTGREEN);
  SetMenuColors(COLOR_WHITE, COLOR_YELLOW, COLOR_LIGHTGREEN, COLOR_GREEN);
  MainMenu();
  ExitScreen();
}



unsigned char MainMenu() {
  Menu *menu;

  enum {
    MM_FILE,
    MM_EDIT,
    MM_INST,
    MM_MUSIC,
    MM_LOGO
  };

  menu = NewMenu();
  SetMenuTitle(menu, "Main Menu");
  AddMenuItem(menu, MM_FILE, ISTATE_NORMAL, "File Menu...");
  AddMenuItem(menu, MM_EDIT, ISTATE_NORMAL, "Edit Sections...");
  AddMenuItem(menu, MM_INST, ISTATE_INACTIVE, "Load Instructions");
  AddMenuItem(menu, MM_MUSIC,ISTATE_INACTIVE, "Load Music");
  AddMenuItem(menu, MM_LOGO, ISTATE_INACTIVE, "Load Logo");
  ShowMenu(menu);

  while (1) {
    switch (SelectMenu(menu)) {
    case MM_FILE:
      HideMenu(menu);
      if (FileMenu()) {
	DestroyMenu(menu);
	return(0);
      } else {
	ShowMenu(menu);
      }
      break;
    case MM_EDIT:
      HideMenu(menu);
      SectionMenu();
      ShowMenu(menu);
      break;
    case MM_INST:
      break;
    case MM_MUSIC:
      break;
    case MM_LOGO:
      break;
    }
  }
 
}



unsigned char FileMenu() {
  Menu *menu;

  enum {
    FM_BACK,
    FM_NEW,
    FM_GENERATE,
    FM_QUIT
  };

  menu = NewMenu();
  SetMenuTitle(menu, "File Menu");
  AddMenuItem(menu, FM_BACK, ISTATE_NORMAL, "Back...");
  AddMenuItem(menu, FM_NEW, ISTATE_INACTIVE, "New Config");
  AddMenuItem(menu, FM_GENERATE, ISTATE_INACTIVE, "Generate Apps");
  AddMenuItem(menu, FM_QUIT, ISTATE_NORMAL, "Quit");
  ShowMenu(menu);

  while (1) {
    switch (SelectMenu(menu)) {
    case FM_BACK:
      HideMenu(menu);
      DestroyMenu(menu);
      return(0);
      break;
    case FM_NEW:
      break;
    case FM_GENERATE:
      break;
    case FM_QUIT:
      HideMenu(menu);
      DestroyMenu(menu);
      return(1);
      break;
    }
  }
}



unsigned char SectionMenu() {
  Menu *menu;

  enum {
    SM_BACK,
    SM_ADD,
    SM_DEL,
    SM_EDIT,
    SM_HELP
  };

  menu = NewMenu();
  SetMenuTitle(menu, "Section Menu");
  AddMenuItem(menu, SM_BACK,ISTATE_NORMAL, "Back...");
  AddMenuItem(menu, SM_ADD, ISTATE_INACTIVE, "Add Section");
  AddMenuItem(menu, SM_DEL, ISTATE_INACTIVE, "Delete Section");
  AddMenuItem(menu, SM_EDIT,ISTATE_INACTIVE, "Edit Section...");
  AddMenuItem(menu, SM_HELP,ISTATE_INACTIVE, "Edit Help Text...");
  ShowMenu(menu);

  while (1) {
    switch (SelectMenu(menu)) {
    case SM_BACK:
      HideMenu(menu);
      DestroyMenu(menu);
      return(0);
      break;
    case SM_ADD:
      break;
    case SM_DEL:
      break;
    case SM_EDIT:
      break;
    case SM_HELP:
      break;
    }
  }
}
